models/Alquileres.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "alquileres".
 *
 * @property int $codigoAlquiler
 * @property int $usuario
 * @property int $coche
 * @property string $fecha
 *
 * @property Coches $coche0
 * @property Usuarios $usuario0
 */
class Alquileres extends \yii\db\ActiveRecord
{
    public $campoyear;
    
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'alquileres';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['usuario', 'coche'], 'integer'],
            [['fecha'], 'safe'],
            [['usuario', 'coche', 'fecha'], 'unique', 'targetAttribute' => ['usuario', 'coche', 'fecha']],
            [['coche'], 'exist', 'skipOnError' => true, 'targetClass' => Coches::className(), 'targetAttribute' => ['coche' => 'codigoCoche']],
            [['usuario'], 'exist', 'skipOnError' => true, 'targetClass' => Usuarios::className(), 'targetAttribute' => ['usuario' => 'codigoUsuario']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'codigoAlquiler' => 'Codigo Alquiler',
            'usuario' => 'Usuario',
            'coche' => 'Coche',
            'fecha' => 'Fecha Alquiler',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getCoche0()
    {
        return $this->hasOne(Coches::className(), ['codigoCoche' => 'coche']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUsuario0()
    {
        return $this->hasOne(Usuarios::className(), ['codigoUsuario' => 'usuario']);
    }
    
     /* metodo nuevo, el listado de fecha sale en castellano */ 
    public function afterFind(){
        parent::afterFind();
        // tendria el año de un registro de alquileres automaticamente de forma dinamica
        // $this->campoyear=Yii::$app->formatter->asDate($this->fecha, 'php:Y');
        $this->fecha=Yii::$app->formatter->asDate($this->fecha, 'php:d/m/Y');
    }
    
    /* antes de grabar, el listado de fecha guarda en castellano*/
    public function beforeSave($insert){
        parent::beforeSave($insert);
        /* $this->fecha=Yii::$app->formatter->asDate($this->fecha, 'php:Y-m-d');  fecha para guardr con formato original*/ 
        $this->fecha= \DateTime::createFromFormat("d/m/Y", $this->fecha)
                -> format("Y/m/d");
        
        return(true);
    }
    
    /* funcion ejemplo   */
    public static function listar(){
        return self::find()->all();
    }
    
    /* funcion combo   */
    
    /* desplegble */
 
    public function getCoches(){
        $coches=\app\models\Coches::find()->all();
        $coches=\yii\helpers\ArrayHelper::map($coches, "codigoCoche", "color","marca");
        return $coches;
    }
    
    
    public function getUsuarios(){
        $usuarios=\app\models\Usuarios::find()->all();
        $usuarios=\yii\helpers\ArrayHelper::map($usuarios, "codigoUsuario", "nombre");
        return $usuarios;
    }
    
    /*   Consulta de alquileres */
    public static function getAlquileresusuarios($id){
        return self::find()
                ->where("usuario=$id");
    }
    
    /*   Consulta de alquileres del año de la fecha */
    public static function getAlquileresyear($id){
        
        /*
         * select year(fecha) from alquileres where cofgoAlquiler=$id
         */
        
        $registro=self::find()
                ->select("YEAR(fecha) campoyear")
                ->where("codigoAlquiler=$id")
                ->one();
        
        $anno=$registro->campoyear;
        
        return self::find()
           ->select("*, YEAR(fecha) campoyear")
           ->where("year(fecha)=$anno");
        
    }
    
        public static function getAlquilerecoche($id){
        return self::find()
                 ->where("coche=$id");
    }
    
}

controllers/AlquileresController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Alquileres;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * AlquileresController implements the CRUD actions for Alquileres model.
 */
class AlquileresController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Alquileres models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Alquileres::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Alquileres model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Alquileres model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Alquileres();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->codigoAlquiler]);
        }
    
        return $this->render('create', [
            'model' => $model,
    
        ]);
    }

    /**
     * Updates an existing Alquileres model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->codigoAlquiler]);
        }
        
        
        
        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Alquileres model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Alquileres model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Alquileres the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Alquileres::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
  
     public function actionAlquileresusuarios($id){
         
//        $dataProvider = new ActiveDataProvider([
//         'query' => Alquileres::find()
//              ->where("usuario=$id"),
//            ]);
                 
         $dataProvider=new ActiveDataProvider([  // consulta sacada del modelo
             'query'=>Alquileres::getAlquileresusuarios($id) // consulta sacada del modelo
         ]);
         
        return $this->render("alquileresusuarios",[
                'dataProvider'=>$dataProvider,
                ]);    
    }
    
    
     public function actionAlquileresyear($id){
         
         $dataProvider=new ActiveDataProvider([  // consulta sacada del modelo
             'query'=>Alquileres::getAlquileresyear($id) // consulta sacada del modelo
         ]);
         
        return $this->render("alquileresyear",[
                'dataProvider'=>$dataProvider,
                ]);    
    }
    
         public function actionAlquilerescoche($id){
             $dataProvider=new ActiveDataProvider([  // consulta sacada del modelo
             'query'=>Alquileres::getAlquilerecoche($id) // consulta sacada del modelo
         ]);
              return $this->render("alquilerescoche",[
                'dataProvider'=>$dataProvider,
                ]);    
         }
    
          public function actionAlquileresmarca($id){
             $dataProvider=new ActiveDataProvider([  // consulta sacada del modelo
             'query'=>Alquileres::find()
                    ->join('INNER JOIN','coches','coches.codigoCoche=alquileres.coche')
                    ->where("marca='$id'")
                 
                 
         ]);
              return $this->render("alquileresmarca",[
                'dataProvider'=>$dataProvider,
                ]);    
         }
         
         
    
}

views/alquileres/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\date\DatePicker;

/* @var $this yii\web\View */
/* @var $model app\models\Alquileres */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="alquileres-form">

    <?php $form = ActiveForm::begin(); ?>

    <!-- cuadro de lista usuarios   -->
    <?= $form->field($model, 'usuario')->dropDownList(
            $model->Usuarios
            ) ?> 
    <!--  fin de cuadro de lista   usuarios  -->
 
    <!-- cuadro de lista coches   -->
    <?= $form->field($model, 'coche')->dropDownList(
            $model->Coches
            ) ?>
    <!--  fin de cuadro de lista   coches  -->

    
    
    <?php
    /* opcion uno del Datapickerd 
    echo '<label class="control-label">'.$model->getAttributeLabel("fecha").'</label>'; //opcion de sacar la eqiqueta de un atributo
    echo DatePicker::widget([
        'model' => $model, 
        'attribute' => 'fecha',
        'options' => ['placeholder' => 'Introduce la fecha de Alquiler'],
        'pluginOptions' => [
            'todayHighlight' => true,
            'todayBtn' => true,
            'autoclose'=>true,
            'format'=>'yyyy/mm/dd',
        ]
    ]);  
     */
    
    echo $form->field($model,'fecha')->widget(DatePicker::className(),[ //opcion 2 de sacar las etiquetas de los atributos
        'options' => ['placeholder' => 'Introduce la fecha de Alquiler'],
        'pluginOptions' => [
            'todayHighlight' => true,
            'todayBtn' => true,
            'autoclose'=>true,
            /* 'format'=>'yyyy/mm/dd',      opcion de guardar con fecha formato original*/ 
            'format'=>'dd/mm/yyyy', 
        ]
    ]);  
    
    
    
    
    ?>
    

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/alquileres/alquilerescoche.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Alquileres';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="alquileres-index">

    
        <div class="jumbotron">
            <h1> Estos son los alquileres de 
            
         <?= $dataProvider->models[0]->coche  ?>
                
            </h1>
        </div>
        
    
    


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'codigoAlquiler',
            'coche',
            'fecha',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>

    <p>
        <?= Html::a('Atras', ['/alquileres/index'], ['class' => 'btn btn-success']) ?>
    </p>

views/alquileres/alquileresmarca.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Alquileres';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="alquileres-index">

    
        <div class="jumbotron">
            <h1> Estos son los alquileres de 
            
         <?= $dataProvider->models[0]->coche  ?>
                
            </h1>
        </div>
        
    
    


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'codigoAlquiler',
            'coche',
            'fecha',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>

    <p>
        <?= Html::a('Atras', ['/alquileres/index'], ['class' => 'btn btn-success']) ?>
    </p>

views/alquileres/alquileresusuarios.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Alquileres';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="alquileres-index">

    
        <div class="jumbotron">
            <h1> Estos son los alquileres de 
            
         <?= $dataProvider->models[0]->usuario0->nombre  ?>
                
            </h1>
        </div>
        
    
    


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'codigoAlquiler',
            'coche',
            'fecha',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>

    <p>
        <?= Html::a('Atras', ['/alquileres/index'], ['class' => 'btn btn-success']) ?>
    </p>

views/alquileres/alquileresyear.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Alquileres del año ';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="alquileres-index">

    
        <div class="jumbotron">
            <h1> Estos son los alquileres de 
            
         <?= $dataProvider->models[0]->campoyear  ?>
             
            </h1>
        </div>
        
    
    


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'codigoAlquiler',
            'coche',
            'fecha',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>

    <p>
        <?= Html::a('Atras', ['/alquileres/index'], ['class' => 'btn btn-success']) ?>
    </p>

views/alquileres/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Alquileres */

$this->title = 'Create Alquileres';
$this->params['breadcrumbs'][] = ['label' => 'Alquileres', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="alquileres-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        
        
            
    ]) ?>

</div>

views/alquileres/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;


/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Alquileres';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="alquileres-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Alquileres', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'codigoAlquiler',
            'usuario',
            'usuario0.nombre', // sacar un dato de otra tabla sin sacar la consulta
            [
                'label'=>'Nombre del usuario',
                'format'=>'raw',
                'content'=>function($ml){
                    return Html::a(
                            'ver aquileres de  '.
                            $ml->usuario0->nombre,
                            [
                                'alquileres/alquileresusuarios',
                                'id'=>$ml->usuario
                            ], 
                            [
                                'class'=>'btn btn-primary'
                            ]
                            );
                }
            ],
            'coche',
             [
                'label'=>'Codigo del coche ',
                'format'=>'raw',
                'content'=>function($ml){
                    return Html::a(
                            'ver coches '.
                            $ml->coche,
                            [
                                'alquileres/alquilerescoche',
                                'id'=>$ml->coche
                            ], 
                            [
                                'class'=>'btn btn-primary'
                            ]
                            );
                }
             ]       
                   
                    
           ,  // sacar un dato de otra tabla sin sacar la consulta
                      [
                'label'=>'Codigo del coche ',
                'format'=>'raw',
                'content'=>function($ml){
                    return Html::a(
                            'ver coches '.
                            $ml->coche,
                            [
                                'alquileres/alquilerescoche',
                                'id'=>$ml->coche
                            ], 
                            [
                                'class'=>'btn btn-primary'
                            ]
                            );
                }
             ]       
            ,  'coche0.marca',
                     // sacar un dato de otra tabla sin sacar la consulta
         
            
                     [
                'label'=>'Codigo del coche ',
                'format'=>'raw',
                'content'=>function($model){
                    return Html::a(
                            'ver coches '.
                            $model->coche0["marca"],
                            [
                                'alquileres/alquilerescoche',
                                'id'=>$model->coche0["marca"]
                            ], 
                            [
                                'class'=>'btn btn-primary'
                            ]
                            );
                }
             ]     
                               
            ,

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/alquileres/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Alquileres */

$this->title = 'Update Alquileres: ' . $model->codigoAlquiler;
$this->params['breadcrumbs'][] = ['label' => 'Alquileres', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->codigoAlquiler, 'url' => ['view', 'id' => $model->codigoAlquiler]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="alquileres-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        
    ]) ?>

</div>

views/alquileres/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Alquileres */

$this->title = $model->codigoAlquiler;
$this->params['breadcrumbs'][] = ['label' => 'Alquileres', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="alquileres-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->codigoAlquiler], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->codigoAlquiler], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'codigoAlquiler',
            'usuario',
            'coche',
            'fecha',
        ],
    ]) ?>

</div>